--[[ $Id$
   Copyright (c) Brett England, 2013

   No commercial use.
   No redistribution at profit.
   All derivative work must retain this message and
   acknowledge the work of the original author.
--]]
local xap = require("xap")
local toggle = require("toggle")
local ui = require("ui")

function newRelayMonitor( param )	
    -- We are not  going to define an onEvent method to handle a button press.
    -- so this MUST be readOnly.
	param.readOnly = true
  	local btn = toggle.newToggle(param)		
	local f = xap.Filter()
	f:add("xap-header","source",param.xapSource)	
	f:callback(function(frame)
					btn:setState(frame:isValue("output.state","state","on"))
				end		
				)				
	xap_server:addFilter(f)
end

display.newImage( "background.png", true)

-- Create QUIT button
ui.newButton{
    text = "Quit", size = 20,
    defaultSrc="buttonBlue.png", defaultX = 298, defaultY=56,
	overSrc = "buttonBlueOver.png", overX = 298, overY=56, 
	x = display.contentCenterX,
	y = display.contentHeight-40,
    onRelease = function() native.requestExit() end
}


-- Setup GLOBAL xap_server object
xap_server = xap.TCPServer("home.dbzoo.com")
xap_server:setSource("dbzoo.corona.applet")

-- At this point we can't really do much...
if not xap_server:isConnected() then  
	ui.newLabel{ bounds={0,display.contentCenterY,
	                     display.contentWidth,display.contentHeight}, 
	             text= xap_server:getErrorMessage(), 
				 align="center", 
				 size=12}
  return
end

-- Create a row of buttons using our newOutputMonitor function()	
xpos=40
for i=1,4 do
	newRelayMonitor{
		text = "Relay "..i, size=16,
		default="glossy_button_red.png", 
		on = "glossy_button_green.png",
		x = xpos,
		y = display.contentCenterY,
		xapSource="dbzoo.livebox.Controller:relay."..i
	}
	xpos = xpos + 80
end

-- Start XAP engine
xap_server:start()

-- Capture application shutdown		
local onSystem = function( event )
    if event.type == "applicationExit" then
        xap_server:stop()
    end
end
Runtime:addEventListener( "system", onSystem )
